Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Member Functions | Static Public Member Functions | List of all members
Botan::Win32_CAPI_EntropySource Class Referencefinal

`#include <es_capi.h>`

Inheritance diagram for Botan::Win32_CAPI_EntropySource:

## Classes
class | CSP_Handle

## Public Member Functions
std::string | name () const override
size_t | poll (RandomNumberGenerator &rng) override
| Win32_CAPI_EntropySource (const std::string &provs="")

## Static Public Member Functions
static std::unique_ptr< Entropy_Source > | create (const std::string &type)

## Detailed Description

Win32 CAPI Entropy Source

Definition at line 19 of file es_capi.h.

## Constructor & Destructor Documentation

Botan::Win32_CAPI_EntropySource::Win32_CAPI_EntropySource | ( | const std::string & | provs = `""` | ) |
| explicit

Win32_Capi_Entropysource Constructor

Parameters

  provs | list of providers, separated by ':'

Definition at line 75 of file es_capi.cpp.

References Botan::split_on().

76 {
77 for(std::string prov_name : split_on(provs, ':'))
78 {
79 DWORD prov_type;
80
81 if(prov_name == "RSA_FULL")
82 prov_type = PROV_RSA_FULL;
83 else if(prov_name == "INTEL_SEC")
84 prov_type = PROV_INTEL_SEC;
85 else if(prov_name == "RNG")
86 prov_type = PROV_RNG;
87 else
88 continue;
89
90 m_csp_provs.push_back(std::unique_ptr<CSP_Handle>(new CSP_Handle_Impl(prov_type)));
91 }
92 }
Botan::split_on
std::vector< std::string > split_on(const std::string &str, char delim)
Definition: parsing.cpp:138

## Member Function Documentation

std::unique_ptr< Entropy_Source > Botan::Entropy_Source::create | ( | const std::string & | type | ) |
| static inherited

Return a new entropy source of a particular type, or null Each entropy source may require substantial resources (eg, a file handle or socket instance), so try to share them among multiple RNGs, or just use the preconfigured global list accessed by Entropy_Sources::global_sources()

Definition at line 45 of file entropy_srcs.cpp.

Referenced by Botan::Entropy_Sources::Entropy_Sources().

46 {
47 if(name == "rdrand")
48 {
49 #if defined(BOTAN_HAS_ENTROPY_SRC_RDRAND)
50 return std::unique_ptr<Entropy_Source>(new Intel_Rdrand);
51 #endif
52 }
53
54 if(name == "rdseed")
55 {
56 #if defined(BOTAN_HAS_ENTROPY_SRC_RDSEED)
57 return std::unique_ptr<Entropy_Source>(new Intel_Rdseed);
58 #endif
59 }
60
61 if(name == "darwin_secrandom")
62 {
63 #if defined(BOTAN_HAS_ENTROPY_SRC_DARWIN_SECRANDOM)
64 return std::unique_ptr<Entropy_Source>(new Darwin_SecRandom);
65 #endif
66 }
67
68 if(name == "getentropy")
69 {
70 #if defined(BOTAN_HAS_ENTROPY_SRC_GETENTROPY)
71 return std::unique_ptr<Entropy_Source>(new Getentropy);
72 #endif
73 }
74
75 if(name == "dev_random")
76 {
77 #if defined(BOTAN_HAS_ENTROPY_SRC_DEV_RANDOM)
78 return std::unique_ptr<Entropy_Source>(new Device_EntropySource(BOTAN_SYSTEM_RNG_POLL_DEVICES));
79 #endif
80 }
81
82 if(name == "win32_cryptoapi")
83 {
84 #if defined(BOTAN_HAS_ENTROPY_SRC_CAPI)
85 return std::unique_ptr<Entropy_Source>(new Win32_CAPI_EntropySource("RSA_FULL"));
86 #endif
87 }
88
89 if(name == "proc_walk")
90 {
91 #if defined(BOTAN_HAS_ENTROPY_SRC_PROC_WALKER)
92 const std::string root_dir = BOTAN_ENTROPY_PROC_FS_PATH;
93 if(!root_dir.empty())
94 return std::unique_ptr<Entropy_Source>(new ProcWalking_EntropySource(root_dir));
95 #endif
96 }
97
98 if(name == "system_stats")
99 {
100 #if defined(BOTAN_HAS_ENTROPY_SRC_WIN32)
101 return std::unique_ptr<Entropy_Source>(new Win32_EntropySource);
102 #endif
103 }
104
105 return std::unique_ptr<Entropy_Source>();
106 }
Botan::Entropy_Source::name
virtual std::string name() const =0

std::string Botan::Win32_CAPI_EntropySource::name | ( |  | ) | const
| inline override virtual

Returns
  name identifying this entropy source

Implements Botan::Entropy_Source.

Definition at line 22 of file es_capi.h.

22 { return "win32_cryptoapi"; }

size_t Botan::Win32_CAPI_EntropySource::poll | ( | RandomNumberGenerator & | rng | ) |
| override virtual

Perform an entropy gathering poll

Parameters

  rng | will be provided with entropy via calls to add_entropy

Returns
  conservative estimate of actual entropy added to rng during poll

Implements Botan::Entropy_Source.

Definition at line 53 of file es_capi.cpp.

References Botan::RandomNumberGenerator::add_entropy().

54 {
55 secure_vector<uint8_t> buf(BOTAN_SYSTEM_RNG_POLL_REQUEST);
56 size_t bits = 0;
57
58 for(size_t i = 0; i != m_csp_provs.size(); ++i)
59 {
60 size_t got = m_csp_provs[i]->gen_random(buf.data(), buf.size());
61
62 if(got > 0)
63 {
64 rng.add_entropy(buf.data(), got);
65 bits += got * 8;
66 }
67 }
68
69 return bits;
70 }

The documentation for this class was generated from the following files:

- src/lib/entropy/cryptoapi_rng/es_capi.h
- src/lib/entropy/cryptoapi_rng/es_capi.cpp